=== debian/changelog ===
hashcat (4.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 4.2.1
  * Update debian/copyright
  * Bump Standards-Version (no change)

 -- Sophie Brun <sophie@freexian.com>  Wed, 22 Aug 2018 15:55:19 +0200

hashcat (4.1.0-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Team upload.
  * New upstream version 4.1.0
  * Refresh patches

  [ Raphaël Hertzog ]
  * Update team maintainer address to Debian Security Tools
    <team+pkg-security@tracker.debian.org>

 -- Sophie Brun <sophie@freexian.com>  Wed, 04 Apr 2018 15:08:31 +0200
