## hashcat 5.0.0

=== src/Makefile ===
--- 
+++ 
@@ -6,7 +6,8 @@
 SHARED                  := 0
 DEBUG                   := 0
 PRODUCTION              := 1
-PRODUCTION_VERSION      := v4.2.1
+PRODUCTION_VERSION      := v5.0.0
+ENABLE_BRAIN            := 1
 
 ##
 ## Detect Operating System
@@ -118,7 +119,7 @@
 ## You have your own headers somewhere, for example: apt-get install opencl-headers
 ##
 
-OPENCL_HEADERS_KHRONOS  := deps/OpenCL-Headers
+OPENCL_HEADERS_KHRONOS  := deps/git/OpenCL-Headers
 
 ##
 ## Cross compiler paths
@@ -151,43 +152,13 @@
 ## General compiler and linker options
 ##
 
-CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/
+LFLAGS                  := $(LDFLAGS)
 
 ifeq ($(PRODUCTION),0)
 CFLAGS                  += -W
 CFLAGS                  += -Wall
 CFLAGS                  += -Wextra
-CFLAGS                  += -Wfloat-equal
-CFLAGS                  += -Wundef
-CFLAGS                  += -Wshadow
-CFLAGS                  += -Wmissing-declarations
-CFLAGS                  += -Wmissing-prototypes
-CFLAGS                  += -Wpointer-arith
-CFLAGS                  += -Wstrict-prototypes
-CFLAGS                  += -Waggregate-return
-CFLAGS                  += -Wswitch-enum
-CFLAGS                  += -Winit-self
-CFLAGS                  += -Werror-implicit-function-declaration
-CFLAGS                  += -Wformat
-CFLAGS                  += -ftrapv
-CFLAGS                  += -Wwrite-strings
-endif
-
-# default Linux and freebsd thread stack size is 2MB
-# default Windows thread stack size is 1MB
-# default macOS thread stack size is 512kB
-# unfortunately, this option isn't supported by older GCC and clang versions
-
-#CFLAGS                  += -Wstack-usage=524288
-
-ifeq ($(SYSTEM_LZMA_SDK),0)
-CFLAGS                  += -Ideps/lzma_sdk/
-else
-CFLAGS                  += $(LZMA_SDK_INCLUDE)
-LDFLAGS                 += -llzmasdk
-endif
-
-LFLAGS                  := $(LDFLAGS)
+endif
 
 ifeq ($(DEBUG),0)
 CFLAGS                  += -O2
@@ -203,6 +174,22 @@
 CFLAGS                  += -fsanitize=address -fno-omit-frame-pointer
 endif
 endif
+endif
+
+CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/
+
+# LZMA
+ifeq ($(SYSTEM_LZMA_SDK),0)
+CFLAGS                  += -Ideps/lzma_sdk
+else
+CFLAGS                  += $(LZMA_SDK_INCLUDE)
+LDFLAGS                 += -llzmasdk
+endif
+
+# brain and xxHash
+ifeq ($(ENABLE_BRAIN),1)
+CFLAGS                  += -DWITH_BRAIN
+CFLAGS                  += -Ideps/git/xxHash
 endif
 
 ##
@@ -262,6 +249,7 @@
 LFLAGS_NATIVE           += -Wl,--dynamicbase -Wl,--nxcompat
 LFLAGS_NATIVE           += -lpsapi
 LFLAGS_NATIVE           += -liconv
+LFLAGS_NATIVE           += -lws2_32
 endif # MSYS2
 
 ##
@@ -299,23 +287,21 @@
 LFLAGS_CROSS_WIN32      := $(LFLAGS)
 LFLAGS_CROSS_WIN32      += -Wl,--dynamicbase -Wl,--nxcompat
 LFLAGS_CROSS_WIN32      += -lpsapi
+LFLAGS_CROSS_WIN32      += -lws2_32
 LFLAGS_CROSS_WIN64      := $(LFLAGS)
 LFLAGS_CROSS_WIN64      += -Wl,--dynamicbase -Wl,--nxcompat
 LFLAGS_CROSS_WIN64      += -lpsapi
-
-CFLAGS_REMOVE_LZMA        := -Wmissing-declarations -Wmissing-prototypes -Wstrict-prototypes -Wundef
-
-CFLAGS_NATIVE_LZMA        := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_NATIVE))
-CFLAGS_CROSS_LINUX32_LZMA := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_LINUX32))
-CFLAGS_CROSS_LINUX64_LZMA := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_LINUX64))
-CFLAGS_CROSS_WIN32_LZMA   := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_WIN32))
-CFLAGS_CROSS_WIN64_LZMA   := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_WIN64))
+LFLAGS_CROSS_WIN64      += -lws2_32
 
 ##
 ## Objects
 ##
 
-OBJS_ALL                := affinity autotune benchmark bitmap bitops combinator common convert cpt cpu_aes cpu_crc32 cpu_des cpu_md4 cpu_md5 cpu_sha1 cpu_sha256 debugfile dictstat dispatch dynloader event ext_ADL ext_nvapi ext_nvml ext_OpenCL ext_sysfs ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface locking logfile loopback memory monitor mpsp opencl outfile_check outfile pidfile potfile restore rp rp_cpu rp_kernel_on_cpu rp_kernel_on_cpu_optimized selftest shared status stdout straight terminal thread timer tuningdb usage user_options wordlist
+OBJS_ALL                := affinity autotune benchmark bitmap bitops combinator common convert cpt cpu_aes cpu_crc32 cpu_des cpu_md4 cpu_md5 cpu_sha1 cpu_sha256 debugfile dictstat dispatch dynloader event ext_ADL ext_nvapi ext_nvml ext_OpenCL ext_sysfs ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface locking logfile loopback memory monitor mpsp opencl outfile_check outfile pidfile potfile restore rp rp_cpu rp_kernel_on_cpu rp_kernel_on_cpu_optimized selftest slow_candidates shared status stdout straight terminal thread timer tuningdb usage user_options wordlist
+
+ifeq ($(ENABLE_BRAIN),1)
+OBJS_ALL                += brain
+endif
 
 NATIVE_STATIC_OBJS      := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.STATIC.o)
 NATIVE_SHARED_OBJS      := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.SHARED.o)
@@ -325,6 +311,19 @@
 
 WIN_32_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.32.o)
 WIN_64_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.64.o)
+
+ifeq ($(ENABLE_BRAIN),1)
+OBJS_XXHASH             := xxhash
+
+NATIVE_STATIC_OBJS      += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).NATIVE.STATIC.o)
+NATIVE_SHARED_OBJS      += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).NATIVE.SHARED.o)
+
+LINUX_32_OBJS           += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).LINUX.32.o)
+LINUX_64_OBJS           += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).LINUX.64.o)
+
+WIN_32_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.32.o)
+WIN_64_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.64.o)
+endif
 
 ifeq ($(SYSTEM_LZMA_SDK),0)
 OBJS_LZMA               := Alloc Lzma2Dec LzmaDec
@@ -397,3 +396,13 @@
 install: install_docs install_shared                                     install_hashcat
 endif
 
+# we need this extra target to make sure that for parallel builds (i.e. 2+ Makefile targets could possible run at the same time)
+# the root folder of the shared directory is created first (and is a dependency for the targets that depend on it)
+
+install_make_library_dev_root:
+	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(LIBRARY_DEV_ROOT_FOLDER)
+
+install_make_shared_root:
+	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(SHARED_ROOT_FOLDER)
+
+install_docs: install_make_shared_root
