=== debian/changelog ===
hashcat (5.0.0-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Team upload.
  * New upstream version 5.0.0
  * Refresh patches
  * Add libxxhash-dev to build-dep
  * Bump Standards-Version to 4.2.1 (no change)
  * Add a patch to use the packaged libxxhash

  [ Raphaël Hertzog ]
  * Switch to debhelper compat level 11

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 08 Nov 2018 14:27:50 +0100
