## hashcat 5.1.0+ds1

=== src/Makefile ===
--- 
+++ 
@@ -6,8 +6,11 @@
 SHARED                  := 0
 DEBUG                   := 0
 PRODUCTION              := 1
-PRODUCTION_VERSION      := v5.0.0
+PRODUCTION_VERSION      := v5.1.0
 ENABLE_BRAIN            := 1
+USE_SYSTEM_LZMA         := 0
+USE_SYSTEM_OPENCL       := 0
+USE_SYSTEM_XXHASH       := 0
 
 ##
 ## Detect Operating System
@@ -78,7 +81,7 @@
 VERSION_PURE            := $(shell echo "$(VERSION_TAG)" | $(SED) 's/.*v\([\.0-9]*\).*/\1/')
 
 ##
-## Installation paths (Linux only)
+## Installation paths
 ##
 
 DESTDIR                 ?=
@@ -93,6 +96,36 @@
 LIBRARY_DEV_FOLDER      ?= $(LIBRARY_DEV_ROOT_FOLDER)/hashcat
 
 ##
+## Depencies paths
+##
+
+ifeq ($(USE_SYSTEM_LZMA),0)
+DEPS_LZMA_PATH          := deps/LZMA-SDK/C
+else
+DEPS_LZMA_PATH          := $(LIBRARY_DEV_ROOT_FOLDER)/
+endif
+
+ifeq ($(USE_SYSTEM_OPENCL),0)
+DEPS_OPENCL_PATH        := deps/OpenCL-Headers
+else
+DEPS_OPENCL_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)/
+endif
+
+ifeq ($(USE_SYSTEM_XXHASH),0)
+DEPS_XXHASH_PATH        := deps/xxHash
+else
+DEPS_XXHASH_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)/
+endif
+
+## To compile win-iconv with mingw clone from here: https://github.com/win-iconv/win-iconv
+##
+## Then patch the makefile with the patches from tools/win-iconv-*.diff and run make install
+##
+
+WIN_ICONV_32            := /opt/win-iconv-32
+WIN_ICONV_64            := /opt/win-iconv-64
+
+##
 ## Filenames for library and frontend
 ##
 
@@ -114,14 +147,6 @@
 endif # MSYS2
 
 ##
-## Dependencies
-## You may ignore them if you're compiling only a native binary and
-## You have your own headers somewhere, for example: apt-get install opencl-headers
-##
-
-OPENCL_HEADERS_KHRONOS  := deps/git/OpenCL-Headers
-
-##
 ## Cross compiler paths
 ##
 
@@ -131,22 +156,11 @@
 CC_WIN_32               := i686-w64-mingw32-gcc
 CC_WIN_64               := x86_64-w64-mingw32-gcc
 
-## To compile win-iconv with mingw clone from here: https://github.com/win-iconv/win-iconv
-##
-## Then patch the makefile with the patches from tools/win-iconv-*.diff and run make install
-##
-
-WIN_ICONV_32            := /opt/win-iconv-32
-WIN_ICONV_64            := /opt/win-iconv-64
-
 ##
 ## Misc stuff
 ##
 
 COMPTIME                := $(shell date +%s)
-SYSTEM_LZMA_SDK         := 0
-
-LZMA_SDK_INCLUDE        := $(LIBRARY_DEV_ROOT_FOLDER)/lzma-sdk/C
 
 ##
 ## General compiler and linker options
@@ -179,17 +193,21 @@
 CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/
 
 # LZMA
-ifeq ($(SYSTEM_LZMA_SDK),0)
-CFLAGS                  += -Ideps/lzma_sdk
-else
-CFLAGS                  += $(LZMA_SDK_INCLUDE)
-LDFLAGS                 += -llzmasdk
-endif
+CFLAGS                  += -I$(DEPS_LZMA_PATH)
+ifeq ($(USE_SYSTEM_LZMA),1)
+LFLAGS                  += -llzmasdk
+endif
+
+# OpenCL
+CFLAGS                  += -I$(DEPS_OPENCL_PATH)
 
 # brain and xxHash
 ifeq ($(ENABLE_BRAIN),1)
 CFLAGS                  += -DWITH_BRAIN
-CFLAGS                  += -Ideps/git/xxHash
+CFLAGS                  += -I$(DEPS_XXHASH_PATH)
+ifeq ($(USE_SYSTEM_XXHASH),1)
+LFLAGS                  += -lxxhash
+endif
 endif
 
 ##
@@ -312,6 +330,20 @@
 WIN_32_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.32.o)
 WIN_64_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.64.o)
 
+ifeq ($(USE_SYSTEM_LZMA),0)
+OBJS_LZMA               := Alloc Lzma2Dec LzmaDec
+
+NATIVE_STATIC_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.STATIC.o)
+NATIVE_SHARED_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.SHARED.o)
+
+LINUX_32_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.32.o)
+LINUX_64_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.64.o)
+
+WIN_32_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.32.o)
+WIN_64_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.64.o)
+endif
+
+ifeq ($(USE_SYSTEM_XXHASH),0)
 ifeq ($(ENABLE_BRAIN),1)
 OBJS_XXHASH             := xxhash
 
@@ -324,18 +356,6 @@
 WIN_32_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.32.o)
 WIN_64_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.64.o)
 endif
-
-ifeq ($(SYSTEM_LZMA_SDK),0)
-OBJS_LZMA               := Alloc Lzma2Dec LzmaDec
-
-NATIVE_STATIC_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.STATIC.o)
-NATIVE_SHARED_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.SHARED.o)
-
-LINUX_32_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.32.o)
-LINUX_64_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.64.o)
-
-WIN_32_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.32.o)
-WIN_64_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.64.o)
 endif
 
 ##
@@ -399,10 +419,3 @@
 # we need this extra target to make sure that for parallel builds (i.e. 2+ Makefile targets could possible run at the same time)
 # the root folder of the shared directory is created first (and is a dependency for the targets that depend on it)
 
-install_make_library_dev_root:
-	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(LIBRARY_DEV_ROOT_FOLDER)
-
-install_make_shared_root:
-	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(SHARED_ROOT_FOLDER)
-
-install_docs: install_make_shared_root
