=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Daniel Echeverry <epsilon77@gmail.com>
-Build-Depends: debhelper (>=10),
+Build-Depends: debhelper (>= 11),
                libgmp-dev,
+               libxxhash-dev,
                opencl-headers
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://hashcat.net/hashcat/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat
