=== debian/changelog ===
hashcat (6.1.1+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 6.1.1+ds1

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 31 Jul 2020 15:09:49 +0200

hashcat (6.0.0+ds1-1) unstable; urgency=medium

  * Team upload.

  [ Sophie Brun ]
  * Add dep/zlib in Files-Excluded (already in Debian)
  * New upstream version 6.0.0+ds1
  * Update description package
  * Update dates in debian/copyright
  * Update URL to https in debian/copyright
  * Refresh patches
  * Use Debian package zlib1g-dev for the build
    - add zlib1g-dev in build-dep
    - debian/rules: USE_SYSTEM_ZLIB=1
  * Use debian package libminizip-dev
    - add libminizip-dev in build-dep
    - debian/rules: export DEB_LDFLAGS_MAINT_APPEND = -lminizip
    - add a patch to change path to minizip/ioapi.h
  * Use upstream installation except for modules/*.so
    - Use upstream install: no more files listed by dh_missing
    - Don't install the modules/.*so in /usr/share/hashcat but in
      /usr/lib/hashcat and add a symlink (see
      https://github.com/hashcat/hashcat/issues/2462)

  [ Raphaël Hertzog ]
  * Stop using DEBUG=1 but patch makefile to ensure we don't strip binaries
    anyway

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 19 Jun 2020 12:20:24 +0200

hashcat (5.1.0+ds1-2) unstable; urgency=medium

  * Team upload.

  [ Samuel Henrique ]
  * Add salsa-ci.yml
  * Fix my name in changelog
  * Configure git-buildpackage

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Sophie Brun ]
  * Add arm64 and armhf in supported arch (see
    https://bugs.kali.org/view.php?id=6010)
  * Update manpage (Closes: #922811)
  * Bump Standards-Version to 4.5.0

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 20 Feb 2020 15:10:37 +0100
