=== debian/control ===
--- 
+++ 
@@ -3,24 +3,26 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Daniel Echeverry <epsilon77@gmail.com>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                libgmp-dev,
+	       libminizip-dev,
                libxxhash-dev,
+	       zlib1g-dev,
                opencl-headers
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Homepage: https://hashcat.net/hashcat/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat
 
 Package: hashcat
-Architecture: kfreebsd-any amd64 i386
+Architecture: kfreebsd-any amd64 i386 armhf arm64
 Depends: hashcat-data (>= ${source:Version}),
          pocl-opencl-icd | opencl-icd,
          ${misc:Depends},
          ${shlibs:Depends}
 Suggests: beignet-opencl-icd, nvidia-opencl-icd, mesa-opencl-icd
 Description: World's fastest and most advanced password recovery utility
- Hashcat supports five unique modes of attack for over 200 highly-optimized
+ Hashcat supports five unique modes of attack for over 300 highly-optimized
  hashing algorithms. hashcat currently supports CPUs, GPUs, and other
  hardware accelerators on Linux, and has facilities to help enable
  distributed password cracking.
