=== debian/rules ===
--- 
+++ 
@@ -1,15 +1,24 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
+
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_LDFLAGS_MAINT_APPEND = -lminizip
+
+MAKEFILE_VARIABLES = PREFIX=/usr COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1 USE_SYSTEM_ZLIB=1
 
 %:
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- PREFIX=/usr DEBUG=1 COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1
+	dh_auto_build -- $(MAKEFILE_VARIABLES)
 
 override_dh_auto_install:
-	dh_auto_install -- USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1
+	dh_auto_install -- $(MAKEFILE_VARIABLES)
+
+override_dh_install:
+	rm -f debian/tmp/usr/share/doc/hashcat/docs/changes.txt
+	rm -f debian/tmp/usr/share/doc/hashcat/docs/license.txt
+	dh_install
 
 override_dh_installchangelogs:
 	dh_installchangelogs docs/changes.txt
